unit UnitMain;
{
    
     -       
  1.  ,  20 : Envelope.Count_frame/Frame_ms ()
  2.   :
      2.1.       ()
      2.2.      ()
      2.3.      ()
  3.   (   Envelope.Count_frame)
  4.  (  )   

}
interface



uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MMSystem, ExtCtrls, UnitDFT, TeEngine, Series, TeeProcs, Chart,
  ComCtrls, StdCtrls, inifiles, Buttons,UnitCommon, UnitImage;


  type

  TData16 = array [0..SizeBufIn-1] of smallint;
  PData16 = ^TData16;

  TForm1 = class(TForm)
    Image1: TImage;
    ChartSpectr: TChart;
    StatusBar1: TStatusBar;
    Series1: TFastLineSeries;
    PanelCtrl: TPanel;
    BitBtnRecord: TBitBtn;
    BitBtnScartOut: TBitBtn;
    ButtonRight: TButton;
    ButtonStopView: TButton;
    ButtonLeft: TButton;
    Series2: TBarSeries;
    RadioButtonHamming: TRadioButton;
    RadioButtonBlackman: TRadioButton;
    RadioButtonBlackmanNuttall: TRadioButton;
    EditLevelPower: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    EditLevelAmpl: TEdit;
    Image2: TImage;
    ButtonSavePat: TButton;
    EditSavePat: TEdit;
    RadioButton1: TRadioButton;
    PanelSpectr: TPanel;
    Timer1: TTimer;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    Label4: TLabel;
    CheckBoxWNoise: TCheckBox;
    BitBtnOutSin: TBitBtn;
    GroupBox4: TGroupBox;
    EditSin1: TEdit;
    Label3: TLabel;
    Label5: TLabel;
    EditSin2: TEdit;
    Label6: TLabel;
    EditNoise: TEdit;
    AddNoise: TCheckBox;
    ButtonCheckNoise: TButton;
    Label7: TLabel;
    EditExpand: TEdit;
    Label8: TLabel;
    EditLevelPlay: TEdit;
    Label9: TLabel;
    EditLevelDif: TEdit;
    Label10: TLabel;
    EditHiFiltr: TEdit;
    CheckBoxHi: TCheckBox;
    GroupBox5: TGroupBox;
    Label11: TLabel;
    EditGain: TEdit;
    RichEdit1: TRichEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BitBtnRecordClick(Sender: TObject);
    procedure BitBtnScartOutClick(Sender: TObject);
    procedure ButtonStopViewClick(Sender: TObject);
    procedure ButtonRightClick(Sender: TObject);
    procedure ButtonLeftClick(Sender: TObject);
    procedure EditLevelPowerExit(Sender: TObject);
    procedure EditLevelAmplExit(Sender: TObject);
    procedure ButtonSavePatClick(Sender: TObject);
    procedure ButtonCheckNoiseClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure BitBtnOutSinClick(Sender: TObject);
    procedure EditExpandExit(Sender: TObject);
    procedure EditLevelPlayExit(Sender: TObject);
    procedure EditLevelDifExit(Sender: TObject);
    procedure EditHiFiltrExit(Sender: TObject);
    procedure CheckBoxHiClick(Sender: TObject);
    procedure EditGainExit(Sender: TObject);
  public
    procedure OnWaveIn(var Msg: TMessage); message MM_WIM_DATA;
    procedure WCard;
    procedure SetParamSpectr;
    procedure CreateSpectr;
    procedure CreateOutBuf;
    procedure CloseAll;
    procedure OutScart;
    procedure BlockCtrl;
  end;

var
  Form1: TForm1;
  WaveFormatEx: TWaveFormatEx;
  WaveOut:HWAVE;//!!
  WaveIn: hWaveIn;
  hBuf: THandle;
  BufHead: TWaveHdr;

  woh:array[0..1]of WAVEHDR; //!!
  bufs:array[0..1,0..SizeBufOut-1]of smallint;//!!

  Bits16: boolean;
  StopIn: boolean;
  StopOut:boolean;
  StopOutScart:boolean;
  StartRecord:boolean;

  DrawScart:boolean;
  StepDrawScart:word;

//  ScaleX:real;
  tt1,tt2,tt3,tt4,tt5:longint;
  period_capture:word;
  X_Chart: array[0..DFT_kmax-1] of string; //  
  Singl_Draw:boolean;
  CheckNoise:boolean;
  FormImage:boolean;
  varini: TIniFile;
  AppPath:string;
implementation

{$R *.dfm}


procedure event_buf_end(h: integer;Msg,UserData,P1,P2:cardinal); stdcall;
begin
if msg = WOM_DONE then waveOutWrite(h,pointer(p1),sizeof(woh[0]));
end;

procedure TForm1.FormCreate(Sender: TObject);
var   k:word;
  pr:real;
  win:integer;
begin

  Form1.Caption:='Sound-Agent';
  Form1.DoubleBuffered := True;

  StartRecord:=false;

  Image1.Picture.Bitmap.Width := Image1.width;
  Image1.Picture.Bitmap.Height:= Image1.height;
  with Image1.Picture.Bitmap.Canvas do begin
    Pen.Style   := psSolid;
    Pen.Color   := clgreen;
    Brush.Style := bsSolid;
    Brush.Color := 0;
    FillRect(Rect(0, 0, Image1.Width, Image1.Height));
    FillRect(ClientRect);
  end;

 Image2.Picture.Bitmap.Width := Image2.width;
 Image2.Picture.Bitmap.Height:= Image2.height;
 with Image2.Picture.Bitmap.Canvas do begin
    Pen.Style   := psSolid;
    Pen.Color   := clred;
    Brush.Style := bsSolid;
    Brush.Color := 0;
    FillRect(Rect(0, 0, Image2.Width, Image2.Height));
  end;

  Image2.Picture.Bitmap.Canvas.Rectangle(0,0,Image2.width,Image2.height);

  DFT := TDFT.Create;
  Envelope := TEnvelope.Create;
  ImDat:=TImageSound.Create;
  ImPat:=TImageSound.Create;
  Compare := TRecognize.Create;

  SetParamSpectr;
  ChartSpectr.TopAxis.Maximum:=DFT.kmax;
  ChartSpectr.TopAxis.Minimum:=0;
  ChartSpectr.BottomAxis.Maximum:=DFT.kmax * discret;
  ChartSpectr.BottomAxis.Minimum:=0;

  tt1:=0;
  tt2:=0;
  tt3:=0;
  tt4:=gettickcount;


 AllBytes:=0;

 for k:=0 to DFT.kmax-1 do
 begin
   pr:=k*discret/DFT.nmax;
   X_Chart[k]:=format('%0.0f',[pr]);
   ChartSpectr.Series[0].AddXY(k,0,X_Chart[k]);
   ChartSpectr.Series[1].AddXY(k,0,X_Chart[k]);
 end;

 RichEdit1.Lines.Add(' (Hz): '+inttostr(discret));
 RichEdit1.Lines.Add('   : '+inttostr(SizeBufOut));
 RichEdit1.Lines.Add('   : '
    + inttostr(DFT_kmax)+'/('
    + inttostr(round((DFT_kmax-1)*discret/DFT.nmax))+'Hz)');
 RichEdit1.Lines.Add(' (ms): '+inttostr(Envelope.Time));
 RichEdit1.Lines.Add(' (ms): '+inttostr(Envelope.Frame_ms));
 RichEdit1.Lines.Add('  : '+inttostr(Envelope.Count_frame));
 RichEdit1.Lines.Add('******************');

 // StatusBar1.Panels[0].Text:=inttostr(Envelope

  AppPath := AnsiUpperCase(ExtractFilePath(ParamStr(0)));
  varini := TIniFile.Create(AppPath+'dftv.ini');

  with Envelope do
  begin
    LevelPower:=varini.ReadInteger('Params','LevelPower',1000);
    LevelAmpl:=varini.ReadInteger('Params','LevelAmpl',1);
    LevelDif:=varini.ReadInteger('Params','LevelDif',10);
    K_expand:=varini.ReadInteger('Params','Expand',10);
    K_HiF:=varini.ReadInteger('Params','HiFiltr',10);
    CheckBoxHi.Checked := (varini.ReadInteger('Params','HiFiltrEnable',0) = 1);
    Ampl:=varini.ReadInteger('Params','LevelPlay',10);
    win:=varini.ReadInteger('Params','Window',0);
    Gain:=varini.ReadInteger('Params','Gain',50);
  end;
  varini.free;
  case win of
   0: RadioButton1.Checked:=true;
   1: RadioButtonHamming.Checked:=true;
   2: RadioButtonBlackman.Checked:=true;
   3: RadioButtonBlackmanNuttall.Checked:=true;
  end;

 CheckBoxHiClick(self);

 Singl_Draw:=false;
 DrawScart:=false;
 StepDrawScart:=0;

 EditLevelPower.Text:=inttostr(Envelope.LevelPower);
 EditLevelAmpl.Text:=inttostr(Envelope.LevelAmpl);
 EditExpand.Text:=inttostr(Envelope.K_expand);
 EditLevelPlay.Text:=inttostr(Envelope.Ampl);
 EditLevelDif.Text:=inttostr(Envelope.LevelDif);
 EditHiFiltr.Text:=inttostr(Envelope.K_HiF);
 EditGain.Text:=inttostr(Envelope.Gain);

 StopOut:=false;
 StopOutScart:=false;
 ExitProgram:=false;

 SetLength(Scart,Envelope.Count_frame);
 SetLength(MaxHarm,Envelope.Count_frame);
 SetLength(mHdata,Envelope.Count_frame);
 SetLength(Power,Envelope.Count_frame);

 SetLength(CountHarm,DFT_kmax);
 SetLength(BufOutScart,(discret * Envelope.Time div 1000));


 SetLength(ImDat.Data,Envelope.Count_frame);
 SetLength(ImDat.MaxHarm,Envelope.Count_frame);
 SetLength(ImDat.Start_dim,Envelope.Count_frame);
 SetLength(ImDat.Stop_dim,Envelope.Count_frame);
 SetLength(ImDat.Power,Envelope.Count_frame);
 SetLength(ImDat.AvgHarm,Envelope.Count_frame);
 SetLength(ImDat.AvgFrame,DFT_kmax);
 SetLength(ImDat.DataUp,Envelope.Count_frame);
 SetLength(ImDat.DataRight,Envelope.Count_frame);
 SetLength(ImDat.DataDown,Envelope.Count_frame);

 SetLength(ImPat.Data,Envelope.Count_frame);
 SetLength(ImPat.MaxHarm,Envelope.Count_frame);
 SetLength(ImPat.Start_dim,Envelope.Count_frame);
 SetLength(ImPat.Stop_dim,Envelope.Count_frame);
 SetLength(ImPat.Power,Envelope.Count_frame);
 SetLength(ImPat.AvgHarm,Envelope.Count_frame);
 SetLength(ImPat.AvgFrame,DFT_kmax);
 SetLength(ImPat.DataUp,Envelope.Count_frame);
 SetLength(ImPat.DataRight,Envelope.Count_frame);
 SetLength(ImPat.DataDown,Envelope.Count_frame);

 Create_Mem;


end;

procedure TForm1.CreateOutBuf;
var
  i:integer;
  sizhalf:integer;

begin

  sizhalf:=Length(BufOutScart) div 2;

  waveOutOpen(@WaveOut,WAVE_MAPPER,@WaveFormatEx,cardinal(@event_buf_end),0,CALLBACK_FUNCTION);//!!
 i:=0;
  fillchar(woh[i],sizeof(woh[i]),0);
  woh[i].lpData:=@(BufOutScart[0]);
  woh[i].dwBufferLength:=sizhalf*2;
  waveOutPrepareHeader(WaveOut,@(woh[i]),sizeof(woh[i]));
  waveOutWrite(WaveOut,@(woh[i]),sizeof(woh[0]));

 i:=1;
  fillchar(woh[i],sizeof(woh[i]),0);
  woh[i].lpData:=@(BufOutScart[sizhalf]);
  woh[i].dwBufferLength:=sizhalf*2;
  waveOutPrepareHeader(WaveOut,@(woh[i]),sizeof(woh[i]));
  waveOutWrite(WaveOut,@(woh[i]),sizeof(woh[0]));

end;



procedure TForm1.SetParamSpectr;
var
    n:integer;
    argsin:real;
begin

 DFT.Create_SinCos;

 SetLength(DFT.Win_Hamming,DFT.nmax);
 SetLength(DFT.Win_Blackman,DFT.nmax);
 SetLength(DFT.Win_BlackmanNuttall,DFT.nmax);


 for n:=0 to DFT.nmax-1 do
 begin
  argsin:=2*pi*n/(DFT.nmax - 1);
  DFT.Win_Hamming[n]:=0.54-0.46*cos(argsin);
  DFT.Win_Blackman[n]:=0.42-0.5*cos(argsin)+0.08*cos(2*argsin);
  DFT.Win_BlackmanNuttall[n]:=0.3635819-0.4891775*cos(argsin)+0.1365995*cos(2*argsin)-0.00106411*cos(3*argsin);
 end;

end;


procedure TForm1.CreateSpectr;
var
 k,i,km:word;
 Re,Im,Ampl:real;
 old_harm:integer;
 diff:integer;
 Ai:integer;
 fazaup:boolean;
 xi,yi:integer;
 sumpower:integer;


 shiftpower:integer;
 scalepower:integer;
 scalex:integer;
 shiftx:integer;
 trigger:boolean;
 ke:integer;
 fe:real;
 trigger_field:boolean;
 amh_i,amh_k:integer;
 st:string;

begin
 tt4:=gettickcount;
 tt3:=tt4;
 sumpower:=0;
 ke:= Envelope.K_expand * DFT.nmax div 2;
 shiftpower:=trunc(Image2.Height/2);
 scalepower:=80;
 scalex:=round(Image2.Width / Envelope.Count_frame);
 shiftx:=(Image2.Width - scalex*Envelope.Count_frame) div 2;

 for k:=0 to DFT_kmax-1 do
 begin
   Re:=DFT.ReDFTQ(k);
   Im:=DFT.ImDFTQ(k);
   Ampl:=Sqrt(Re*Re+Im*Im);
//   Ampl:=abs(Re)+abs(Im);
   if k=0 then Ampl:=0 else  Ai:=byte(round(Ampl/ke*Envelope.hifiltr[k])); //     
//   if k=0 then Ampl:=0 else  Ai:=round(Ampl/ke*Envelope.hifiltr[k]);
////////////////////////
   if StartRecord then
   begin
    Scart[Envelope.tick][k]:=Ai;

    if k=0 then
    begin
      MaxHarm[Envelope.tick][k]:=0;
      old_harm:=Ai;
      fazaup:=true;
    end else
    begin
      diff:= old_harm-Ai;
      trigger:=Ai > envelope.LevelAmpl;
      if trigger then
       if diff > envelope.LevelDif then
       begin
         if fazaup then
         begin
           MaxHarm[Envelope.tick][k-1]:=1;
//           inc(Envelope.Activ_Harm[k-1]);
           fazaup:=false;
         end
           else MaxHarm[Envelope.tick][k-1]:=0;
       end
        else
       begin
         MaxHarm[Envelope.tick][k-1]:=0;
         fazaup:=true;
       end;
       old_harm:=Ai;
    end;
/////////////////////////
   end;
   ChartSpectr.Series[0].AddXY(k,Ai,X_Chart[k]);
   sumpower:=sumpower+Ai;

   if StartRecord then
    begin
      if (sumpower > MaxNoise ) then  MaxNoise:=sumpower;
      Power[Envelope.tick]:=sumpower;
     end;
 end; //k


 if StartRecord then
 begin

  if (not Envelope.flipstart) and (sumpower > Envelope.LevelPower) then
  begin
    Envelope.Start_dim[Envelope.tick]:=Envelope.tick+1;//  
    Envelope.flipstart:=true;
    if Envelope.min_X = 0 then Envelope.min_X:=Envelope.tick;
  end;
  if Envelope.flipstart and (sumpower < Envelope.LevelPower) then
  begin
    Envelope.Stop_dim[Envelope.tick]:=Envelope.tick+1;
    Envelope.flipstart:=false;
  end;
  if Envelope.flipstart and (Envelope.tick = Envelope.Count_frame-1) then
     Envelope.Stop_dim[Envelope.tick]:=Envelope.tick+1;

  if (Envelope.Stop_dim[Envelope.tick] > 0) and (Envelope.max_X < Envelope.Count_frame) then Envelope.max_X:=Envelope.tick;

  //  
  xi:=Envelope.tick*scalex+shiftx;
  yi:=trunc(sumpower/scalepower)+1;
  Image2.Picture.Bitmap.Canvas.MoveTo(xi,shiftpower-yi);
  Image2.Picture.Bitmap.Canvas.LineTo(xi,shiftpower+yi);

  Delay_ind[Envelope.tick]:=gettickcount - tt3;

  inc(Envelope.tick);

// Stop record!
  if Envelope.tick >= Envelope.Count_frame then
  begin
    StartRecord:=false;
    BlockCtrl;
    StatusBar1.Panels[3].Text:=inttostr(gettickcount - tt1);
    BitBtnRecord.Font.Color:=clWindowText;

    ActivHarm:=0;
    MaxHarmValue:=0;
    NumberMaxHarm:=0;

    amh_i:=0;
    for i:=0 to Envelope.Count_frame - 1 do //        
    begin
     amh_k:=0;
     trigger_field:= (i >= Envelope.min_X) and (i <= Envelope.max_X);
     if trigger_field then
     begin
      inc(amh_i);
      SetLength(ActivMaxHarm,amh_i);
     end;
     for k:=0 to DFT.kmax-1 do
     begin
       if MaxHarm[i][k] > 0 then
       begin
          inc(ActivHarm);
          inc(Envelope.CountHarmFrame[i]);
          if trigger_field then
          begin
           inc(amh_k);
           SetLength(ActivMaxHarm[amh_i-1],amh_k);
           ActivMaxHarm[amh_i-1][amh_k-1]:=(k shl 8) or Scart[i][k];
          end;
       end;
       if Scart[i][k] > MaxHarmValue then
       begin
         MaxHarmValue:=Scart[i][k];
         NumberMaxHarm:=k;
       end;
       ImDat.AvgFrame[k]:=ImDat.AvgFrame[k]+Scart[i][k];
     end;//k

     ImDat.AvgHarm[i]:=Power[i] / DFT_kmax;

     if Envelope.Start_dim[i] > 0 then
      begin
        xi:=(Envelope.Start_dim[i]-1)*scalex+shiftx-2;
        Image2.Picture.Bitmap.Canvas.Pen.Color   := clyellow;
        Image2.Picture.Bitmap.Canvas.MoveTo(xi,1);
        Image2.Picture.Bitmap.Canvas.LineTo(xi,Image2.Height-1);
        RichEdit1.Lines.Add('Start: '+inttostr(Envelope.Start_dim[i]-1));
      end;
     if Envelope.Stop_dim[i] > 0 then
      begin
        Image2.Picture.Bitmap.Canvas.Pen.Color   := clwhite;
        xi:=(Envelope.Stop_dim[i]-1)*scalex+shiftx+2;
        Image2.Picture.Bitmap.Canvas.MoveTo(xi,1);
        Image2.Picture.Bitmap.Canvas.LineTo(xi,Image2.Height-1);
        RichEdit1.Lines.Add('Stop: '+inttostr((Envelope.Stop_dim[i]-1)));
      end;

     if delay_ind[i] <> 0 then StatusBar1.Panels[0].Text:='Delay: '+inttostr(delay_ind[i]);
    end;//i pass 2

    if not CheckNoise then Lmem_sound[0].AddData(ActivMaxHarm,Envelope.min_X,Envelope.max_X);
    if (Length(Lmem_sound[0].Same) <> same_info) then  same_info:=Length(Lmem_sound[0].Same);
//    for k:=0 to DFT.kmax-1 do ImDat.AvgFrame[k]:= ImDat.AvgFrame[k] / Envelope.Count_frame;//suka!

    RichEdit1.Lines.Add(' : '+inttostr(ActivHarm));//     
    RichEdit1.Lines.Add(' : '+inttostr(NumberMaxHarm)+
        '('+inttostr(round(NumberMaxHarm*discret/DFT.nmax))+'Hz)'+
        '/'+inttostr(MaxHarmValue));
    RichEdit1.Lines.Add('min_X: '+inttostr(Envelope.min_X));
    RichEdit1.Lines.Add('max_X: '+inttostr(Envelope.max_X));
    RichEdit1.Lines.Add(' : '+inttostr(Length(Lmem_sound[0].Data)));
    RichEdit1.Lines.Add('  : '+inttostr(same_info));
    st:='';
    if same_info > 0 then
      for i:=0 to same_info - 1 do st:=st +','+ inttostr(Length(Lmem_sound[0].Data[Lmem_sound[0].Same[i][0]]));

    AllBytes:=0;
    if not CheckNoise then for i:=0 to Length(Lmem_sound[0].Data) - 1 do
     AllBytes:=AllBytes + Length(Lmem_sound[0].Data[i])*2;

    RichEdit1.Lines.Add(': '+inttostr(AllBytes));
    RichEdit1.Lines.Add('  : '+st);

    if CheckNoise then
    begin
      RichEdit1.Lines.Add(' : '+inttostr(MaxNoise));
      Envelope.LevelPower:=MaxNoise;
      EditLevelPower.Text:=inttostr(MaxNoise);
    end;
    RichEdit1.Lines.Add('-----------------------');
    Image2.Picture.Bitmap.Canvas.Pen.Color   := clred;
    CheckNoise:=false;
  end;// stop record
 end;//record
end;

procedure TForm1.CloseAll;
var n:word;
 win:integer;
begin

  AppPath := AnsiUpperCase(ExtractFilePath(ParamStr(0)));
  varini := TIniFile.Create(AppPath+'dftv.ini');


  if RadioButton1.Checked then win:=0;
  if RadioButtonHamming.Checked then win:=1;
  if RadioButtonBlackman.Checked then win:=2;
  if RadioButtonBlackmanNuttall.Checked then win:=3;


  with Envelope do
  begin
    varini.WriteInteger('Params','LevelPower',LevelPower);
    varini.WriteInteger('Params','LevelAmpl',LevelAmpl);
    varini.WriteInteger('Params','LevelDif',LevelDif);
    varini.WriteInteger('Params','Expand',K_Expand);
    varini.WriteInteger('Params','HiFiltr',K_HiF);
    if CheckBoxHi.Checked then varini.WriteInteger('Params','HiFiltrEnable',1)
                          else varini.WriteInteger('Params','HiFiltrEnable',0);
    varini.WriteInteger('Params','LevelPlay',Ampl);
    varini.WriteInteger('Params','Window',win);
    varini.WriteInteger('Params','Gain',Gain);
  end;
  varini.free;






  FreeAndNil(DFT);
  FreeAndNil(Envelope);
  FreeAndNil(ImDat);
  FreeAndNil(ImPat);
  for n:=0 to CountMemLevel - 1 do  Lmem_Sound[n].Sleep;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);

begin
  //   ,  
  StopOut:=false;

  WCard;
  ExitProgram:=true;
  if FormImage then Form2.Close;
  ButtonCheckNoise.SetFocus;



end;

procedure TForm1.WCard;
var
//  header: TWaveFormatEx;
  BufLen: word;
  buf: pointer;

begin
  StopIn := not StopIn;
  if StopIn then
  begin
    bits16 := True;   //  false  8 
    with WaveFormatEx do
    begin
      wFormatTag := WAVE_FORMAT_PCM;
      nChannels := 1;
      nSamplesPerSec := discret;
      wBitsPerSample := integer(Bits16) * 8 + 8; //       
      nBlockAlign := nChannels * (wBitsPerSample div 8);//       
      nAvgBytesPerSec := nSamplesPerSec * nBlockAlign;//      
      cbSize := 0;
    end;

    WaveInOpen(Addr(WaveIn), WAVE_MAPPER, addr(WaveFormatEx), Handle, 0, CALLBACK_WINDOW);
    BufLen := WaveFormatEx.nBlockAlign * SizeBufIn;
    hBuf := GlobalAlloc(GMEM_MOVEABLE and GMEM_SHARE, BufLen);
    Buf := GlobalLock(hBuf);

    with BufHead do
    begin
      lpData := Buf;
      dwBufferLength := BufLen;
      dwFlags:= WHDR_BEGINLOOP
    end;
    WaveInPrepareHeader(WaveIn, Addr(BufHead), sizeof(BufHead));

    WaveInAddBuffer(WaveIn, addr(BufHead), sizeof(BufHead));

    WaveInStart(WaveIn);
  end
  else begin
    WaveInReset(WaveIn);
    WaveInUnPrepareHeader(WaveIn, addr(BufHead), sizeof(BufHead));
    WaveInClose(WaveIn);
    GlobalUnlock(hBuf);
    GlobalFree(hBuf);
  end;
end;

procedure TForm1.OnWaveIn;
var
  i: integer;
  tmpBuf: array of smallint;
  data16: PData16;
  tmpX, tmpY: integer;
//   
  win:real;
  kX,kY1:single;
  kY2:integer;

begin
    if ExitProgram then begin
     CloseAll;
     Exit;
    end;

    data16 := PData16(PWaveHdr(Msg.lParam)^.lpData);
    SetLength(tmpBuf, SizeBufIn);

    kX:=Image1.Width/Length(tmpBuf);
    kY1:=Image1.Height/32767;
    kY2:=Image1.Height div 2;
    if not Singl_Draw then
    begin
      Image1.Refresh;
      Image1.Picture.Bitmap.Canvas.Rectangle(0, 0, Image1.Width, Image1.Height);
      Image1.Picture.Bitmap.Canvas.MoveTo(0, Image1.Height);
      for i := 0 to SizeBufIn - 1 do
      begin
        tmpBuf[i] := data16^[i];
//////   /////////////////
        tmpX := Round(i*kX);
        tmpY := round(kY1 * tmpBuf[i]) + kY2;
        Image1.Picture.Bitmap.Canvas.LineTo(tmpX, tmpY);

        win:=1;
        if RadioButtonHamming.Checked then win:=DFT.Win_Hamming[i];
        if RadioButtonBlackman.Checked then win:=DFT.Win_Blackman[i];
        if RadioButtonBlackmanNuttall.Checked then win:=DFT.Win_BlackmanNuttall[i];

        DFT.fdata[i]:=round(tmpBuf[i]*win);

/////////////////////////////////////////////

      end;
      ChartSpectr.Series[0].Clear;
      ChartSpectr.Series[1].Clear;
      CreateSpectr;
    end
    else
    begin
      Image1.Picture.Bitmap.Canvas.Font.Color:=clwhite;
      Image1.Picture.Bitmap.Canvas.TextOut(20,20,'Stop, press mouse right button...');
    end;

  if StopIn then WaveInAddBuffer(WaveIn, PWaveHdr(Msg.lParam),SizeOf(TWaveHdr))
  else StopIn:= True;
  Update;      //  -...

end;


procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if (Button = mbLeft) then Singl_Draw:=true;
if (Button = mbRight) then
 begin
  Singl_Draw:=false;
  ButtonStopViewClick(self);
 end;
end;


procedure TForm1.BitBtnRecordClick(Sender: TObject);
var k,n:integer;
begin
  StartRecord:=StartRecord xor true;
  if StartRecord then
  begin
    BlockCtrl;
    Image2.Picture.Bitmap.Canvas.FillRect(Rect(1,1,Image2.Width-1,Image2.Height-1));
    tt1:=gettickcount;
    BitBtnRecord.Font.Color:=clRed;

    Envelope.flipstart:=false;
    Envelope.flipstop:=false;

    for n:=0 to Envelope.Count_frame-1 do
    begin
     Envelope.Start_dim[n]:=0;
     Envelope.Stop_dim[n]:=0;
     Envelope.CountHarmFrame[n]:=0;
    end;
    for k:=0 to DFT_kmax - 1 do ImDat.AvgFrame[k]:=0;
    
    Envelope.min_X:=0;
    Envelope.max_X:=0;

  end
  else BitBtnRecord.Font.Color:=clWindowText;

  SetLength(Scart,Envelope.Count_frame);
  SetLength(MaxHarm,Envelope.Count_frame);
  Envelope.tick:=0;
  SetLength(Delay_ind,Envelope.Count_frame);

end;

procedure TForm1.BitBtnScartOutClick(Sender: TObject);
begin
 OutScart;
end;

procedure TForm1.OutScart;
var i,sum,f,k,n:integer;
    sizhalf:integer;
    pri,Ahi:integer;
    ft: TextFile;
    stf:string;
    argsin:real;
    win:real;
    Ampl:integer;
begin

 StopOutScart := StopOutScart xor true;
 if StopOutScart then
 begin
    BlockCtrl;
    BitBtnScartOut.Font.Color:=clRed;
    stf:='export_rec.dat';

    Envelope.flipstart:=false;
    Envelope.flipstop:=false;

    Ampl:=Envelope.Ampl;
    if RadioButtonHamming.Checked then Ampl:=Envelope.Ampl*2;
    if RadioButtonBlackman.Checked then Ampl:=Envelope.Ampl*2;
    if RadioButtonBlackmanNuttall.Checked then Ampl:=Envelope.Ampl*2;

    AssignFile(ft, stf);
    Rewrite(ft);
    Writeln(ft,#9+' (Hz): '+inttostr(WaveFormatEx.nSamplesPerSec)+#9);
    Writeln(ft,'*******');

    sizhalf:=discret * Envelope.Time div 1000 div 2;

    n:=0; //0..319
    f:=0; //  0..49
    sum:=0;
    Ahi:=1;

    for k:=0 to DFT_kmax-1 do CountHarm[k]:=0;//  

    for i:=0 to sizhalf*2-1 do  //     2 
    begin
      sum:=0;
      for k:=3 to DFT_kmax-1 do
      begin
        if (MaxHarm[f][k] > 0) and (Scart[f][k] > Envelope.LevelMax) then
        begin
           //if k>20 then Ahi:=4 else Ahi:=1;

           if (not Envelope.flipstop) and (Envelope.Start_dim[f] > 0) then
           begin
            Envelope.flipstart:=true;
            Envelope.flipstop:=true;
           end;
           if Envelope.flipstop and (Envelope.Stop_dim[f] > 0) then
           begin
            Envelope.flipstart:=false;
            Envelope.flipstop:=false;
           end;

           Envelope.flipstart:=not((not (Envelope.flipstart)) and CheckBoxWNoise.Checked);

           if Envelope.flipstart then
             begin
              pri:=trunc(Ampl*Ahi*Scart[f][k]*sin(2*pi*CountHarm[k]*k/DFT.nmax));
              //!!!!!!! 16     !!!!!
//              pri:=trunc(Ampl*Ahi*(byte(Scart[f][k]) div 16)*sin(2*pi*CountHarm[k]*k/DFT.nmax));
              sum:=smallint(sum+pri);
             end
        end;
      end;//k


      win:=1;
{
      argsin:=2*pi*i/(SizeBufIn - 1);
      if RadioButtonHamming.Checked then win:=0.54-0.46*cos(argsin);
      if RadioButtonBlackman.Checked then win:=0.42-0.5*cos(argsin)+0.08*cos(2*argsin);
}
      BufOutScart[i]:=round(sum*win);
      writeln(ft,inttostr(BufOutScart[i]));

      if n = SizeBufIn -1 then // 
      begin
        if (n = SizeBufIn -1) and CheckBoxWNoise.Checked then  BufOutScart[i]:=0;
        inc(f);
        n:=-1;
        sum:=0;
      end;
      inc(n);

      for k:=0 to DFT_kmax-1 do
       if MaxHarm[f][k] > 0 then inc(CountHarm[k])  else CountHarm[k]:=0;

    end;//i
    closefile(ft);
    waveOutReStart(WaveOut);
 end
    else
 begin
  waveOutPause(WaveOut);
  BitBtnScartOut.Font.Color:=clWindowText;
  BlockCtrl;
 end;
end;//Scart







procedure TForm1.ButtonStopViewClick(Sender: TObject);
begin
  StepDrawScart:=0;
  DrawScart:=false;
  Singl_Draw:=false;
  Statusbar1.Panels[3].Text:='';
end;

procedure TForm1.ButtonRightClick(Sender: TObject);
var k:integer;
begin
  if not DrawScart then
  begin
    StepDrawScart:=0;
    DrawScart:=true;
    Singl_Draw:=true;
  end else
  begin
    inc(StepDrawScart);
    if StepDrawScart = envelope.Count_frame then StepDrawScart:=0;
  end;
  ChartSpectr.Series[0].Clear;
  ChartSpectr.Series[1].Clear;
  Statusbar1.Panels[3].Text:=inttostr(StepDrawScart);
  for k:=0 to DFT_kmax-1 do
  begin
   ChartSpectr.Series[0].AddXY(k,Scart[StepDrawScart][k],X_Chart[k]);
   ChartSpectr.Series[1].AddXY(k,Scart[StepDrawScart][k]*MaxHarm[StepDrawScart][k],X_Chart[k]);
  end;
end;

procedure TForm1.ButtonLeftClick(Sender: TObject);
var k:integer;
begin
  if not DrawScart then
  begin
    StepDrawScart:=0;
    DrawScart:=true;
    Singl_Draw:=true;
  end else
  begin
    if StepDrawScart = 0 then StepDrawScart:=envelope.Count_frame;
    dec(StepDrawScart);
  end;
  ChartSpectr.Series[0].Clear;
  ChartSpectr.Series[1].Clear;
  Statusbar1.Panels[3].Text:=inttostr(StepDrawScart);
  for k:=0 to DFT_kmax-1 do
  begin
   ChartSpectr.Series[0].AddXY(k,Scart[StepDrawScart][k],X_Chart[k]);
   ChartSpectr.Series[1].AddXY(k,Scart[StepDrawScart][k]*MaxHarm[StepDrawScart][k],X_Chart[k]);
  end;
end;

procedure TForm1.EditLevelPowerExit(Sender: TObject);
begin
 Envelope.LevelPower:=strtoint(EditLevelPower.Text);
end;
procedure TForm1.EditLevelAmplExit(Sender: TObject);
begin
 Envelope.LevelAmpl:=strtoint(EditLevelAmpl.Text);
end;

procedure TForm1.ButtonSavePatClick(Sender: TObject);
var i,k:integer;
fpat:TextFile;
fbin:file;
st,stb:string;
stframe:string;
nwrite:integer;
nbuf:integer;


fs:TFileStream;
ms:TMemoryStream;

siz1,siz2,siz3:integer;
fileexist:boolean;
begin
    if not FormImage then   Application.CreateForm(TForm2, Form2) else Form2.SetFocus;
    fileexist:= not (EditSavePat.Text ='');
    st:=EditSavePat.Text+'.dat';
    stb:=EditSavePat.Text+'.bin';

    //              

    ms := TMemoryStream.Create;
    if fileexist then fs := TFileStream.Create(stb,fmCreate or fmOpenWrite);

    siz1:=DFT_kmax*sizeof(Scart[0][0]);
    siz2:=Envelope.Count_frame*sizeof(Envelope.Start_dim[0]);
    siz3:=DFT_kmax*sizeof(single);

    ms.Seek(0, soFromBeginning);
    for i:=0 to Envelope.Count_frame - 1 do
    begin
     ms.WriteBuffer(Scart[i],siz1);
     if fileexist then fs.WriteBuffer(Scart[i],siz1);
    end;
    for i:=0 to Envelope.Count_frame - 1 do
    begin
     ms.WriteBuffer(MaxHarm[i],siz1);
     if fileexist then fs.WriteBuffer(MaxHarm[i],siz1);
    end;

    ms.WriteBuffer(Envelope.Start_dim[0],siz2);
    if fileexist then fs.WriteBuffer(Envelope.Start_dim[0],siz2);

    ms.WriteBuffer(Envelope.Stop_dim[0],siz2);
    if fileexist then fs.WriteBuffer(Envelope.Stop_dim[0],siz2);

    ms.WriteBuffer(Power[0],siz2);
    if fileexist then fs.WriteBuffer(Power[0],siz2);

    if fileexist then fs.WriteBuffer(ImDat.AvgHarm[0],siz2);

    if fileexist then fs.WriteBuffer(ImDat.AvgFrame[0],siz3);


    if fileexist then  fs.Free;
    ms.Seek(0, soFromBeginning);
    for i:=0 to Envelope.Count_frame - 1 do ms.ReadBuffer(ImDat.data[i],siz1);
    for i:=0 to Envelope.Count_frame - 1 do ms.ReadBuffer(ImDat.maxharm[i],siz1);
    ms.ReadBuffer(ImDat.Start_dim[0],siz2);
    ms.ReadBuffer(ImDat.Stop_dim[0],siz2);
    ms.ReadBuffer(ImDat.Power[0],siz2);

    ms.Free;

    Form2.DrawImage(Form2.ImageData,ImDat.Data,ImDat.MaxHarm,true);

    if fileexist then //   ,  
    begin
     AssignFile(fpat, st);
     Rewrite(fpat);
     for i:=0 to (Envelope.Count_frame - 1) do //Power
     begin
       stframe:='';
       begin
        for k:=0 to (DFT_kmax -1) + 2 do //start_dim + Stop_dim
        begin
         if k < (DFT_kmax) then stframe:=stframe+inttostr(Scart[i][k])+#9;
         if k = DFT_kmax then stframe:=stframe+inttostr(Envelope.Start_dim[i])+#9;
         if k = DFT_kmax + 1 then stframe:=stframe+inttostr(Envelope.Stop_dim[i])+#9;
        end;
        writeln(fpat,stframe);
       end
     end;
     CloseFile(fpat);
    end;
    EditSavePat.Text:='';
end;



procedure TForm1.ButtonCheckNoiseClick(Sender: TObject);
begin
  MaxNoise:=0;
  CheckNoise:=true;
  BitBtnRecordClick(self);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin

 Timer1.Enabled:=false;
 FmainLeft:=Left;
 Fmaintop:=Top;
 WCard;
 CreateOutBuf;
 waveOutPause(WaveOut);

end;

procedure TForm1.BitBtnOutSinClick(Sender: TObject);
var i:integer;
    sizhalf:integer;
    sin1:integer;
    sin2:integer;
    noiseout:integer;
    RangNoise:integer;
begin
 StopOut := StopOut xor true;
 if StopOut then
 begin
  BitBtnOutSin.Font.Color:=clred;
  BitBtnOutSin.Caption:='Stop';
  Randomize;
  sizhalf:=Length(BufOutScart) div 2;
  sin1:=strtoint(EditSin1.Text);
  sin2:=strtoint(EditSin2.Text);
  noiseout:=strtoint(EditNoise.Text);
  RangNoise:=1;


  for i:=0 to sizhalf-1 do
  begin
    if AddNoise.checked then RangNoise:=2*(random(2000));
    BufOutScart[i]:=smallint(trunc( 2000*sin(2*pi*i*sin1/discret) + 2000*sin(2*pi*i*sin2/discret)
    + RangNoise*sin(2*pi*i*noiseout/discret)));
  end;
  for i:=sizhalf to sizhalf*2-1 do
  begin
    if AddNoise.checked then RangNoise:=2*(random(2000));
    BufOutScart[i]:=smallint(trunc( 2000*sin(2*pi*i*(sin1+50)/discret) + 2000*sin(2*pi*i*(sin2+50)/discret)
    + RangNoise*sin(2*pi*i*noiseout/discret)));
  end;

  waveOutReStart(WaveOut);
 end
   else
 begin
  waveOutPause(WaveOut);
  BitBtnOutSin.Font.Color:=clWindowText;
  BitBtnOutSin.Caption:='Start';
 end;

end;

procedure TForm1.BlockCtrl;
var block:boolean;
begin
 BitBtnRecord.enabled:= not StopOutScart;
 BitBtnScartOut.enabled:=not StartRecord;
 block:=(not StopOutScart) and (not StartRecord);
 ButtonSavePat.Enabled:= block;
 ButtonStopView.Enabled:=block;
 ButtonLeft.Enabled:=block;
 ButtonRight.Enabled:=block;
 CheckBoxWNoise.Enabled:=block;
 ButtonCheckNoise.Enabled:=block;
 BitBtnOutSin.Enabled:=block;

end;



procedure TForm1.EditExpandExit(Sender: TObject);
begin
  Envelope.K_expand:=strtoint(EditExpand.Text);
end;

procedure TForm1.EditLevelPlayExit(Sender: TObject);
begin
 Envelope.Ampl:=strtoint(EditLevelPlay.Text);
end;

procedure TForm1.EditLevelDifExit(Sender: TObject);
begin

 Envelope.LevelDif:=strtoint(EditLevelDif.Text);
end;

procedure TForm1.EditHiFiltrExit(Sender: TObject);
begin
 Envelope.K_HiF:=strtoint(EditHiFiltr.Text);
end;

procedure TForm1.CheckBoxHiClick(Sender: TObject);
var k,km:integer;
begin
     for k:=0 to DFT_kmax-1 do
     begin
      if k> Envelope.K_HiF then km:=Envelope.Gain else km:=k;
      if CheckBoxHi.Checked then Envelope.hifiltr[k]:=round(km/(DFT_kmax-1)*Envelope.K_expand)+1 //
      else  Envelope.hifiltr[k]:=1;
     end;
end;

procedure TForm1.EditGainExit(Sender: TObject);
begin
 Envelope.Gain:=strtoint(EditGain.Text);
end;

end.
